// Learn TypeScript:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/typescript.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property} = cc._decorator;

@ccclass
export default class View extends cc.Component {

    @property(cc.Label)
    label: cc.Label = null;

    @property(cc.Button)
    mask: cc.Button = null;

    @property(cc.Node)
    btns: cc.Node = null;

    private _maskClickCount = 0;
    private _maskMaxClickCount = 5;
    btnMaskClick () {
        if (this._maskClickCount < this._maskMaxClickCount) {
            this._maskClickCount++
            this.label.string = `Mask click count: ${this._maskClickCount }/${this._maskMaxClickCount}`
        } else {
            this.mask.interactable = false
            this.btns.active = true
            this._maskClickCount = 0
            this.label.string = 'Show Bug button!'
        }
    }
    btnNoramlClick () {
        this.label.string = 'Normal button click!'
        this.close()
    }

    btnBugClick () {
        this.label.string = 'Bug button click!'
        this.btns.active = false
        this.mask.interactable = true
    }

    // onDestroy() {
    //     console.log("View onDestroy");        
    // }

    close() {
        this.node.removeFromParent()
    }
}
